require "version"

#clase principal de la jerarquía
class Dieta

	#Módulo
	include Comparable

	#attr
	attr_accessor :nombre, :titulo, :porcentaje_ingesta, :vct, :proteinas, :grasas, :hidratos, :platos, :nplatos

	#constructor
	def initialize (nombre, &block)
		self.nombre = nombre
		self.titulo
		self.porcentaje_ingesta
		self.nplatos

		self.platos = []

		self.vct
		self.proteinas
		self.grasas
		self.hidratos

		if block_given?
      if block.arity == 1
        yield self
      else
       instance_eval &block
      end
    end
	end

	#función para definir el título del menú: almuerzo, cena, etc.
	def tipo(ntitulo)
		self.titulo = ntitulo
	end

	#función para definir el porcentaje de ingesta. Podría darse una estimación entre dos
	def ingesta(porcentaje = {})
		standard = porcentaje[:fijo] if porcentaje[:fijo]
		low = porcentaje[:min] if porcentaje[:min]
		up = porcentaje[:max] if porcentaje[:max]

		if porcentaje[:fijo] then
			self.porcentaje_ingesta = "#{standard}%"
		else
			self.porcentaje_ingesta = "#{low}% - #{up}%"
		end
	end

	#función para definir los porcentajes de grasa, proteínas, hidratos y el valor calórico total
	def porcentajes(options = {})
		self.vct = options[:vct] if options[:vct]
		self.proteinas = options[:proteinas] if options[:proteinas]
		self.grasas = options[:grasas] if options[:grasas]
		self.hidratos = options[:hidratos] if options[:hidratos]
	end

	#función para definir platos nuevos
	def plato(options = {})
		nuevo = []
		nuevo << "#{options[:descripcion]}" if options[:descripcion]
		nuevo << "#{options[:porcion]}" if options[:porcion]
		nuevo << options[:gramos] if options[:gramos]
		platos << nuevo
	end

	#acceso a un plato en concreto
	def get_plato (n)
		if n < 1 then
			return ""
		end
		return platos[n-1]
	end

	#invalidación del <=> para hacer los objetos comparables
	def <=> (other)
		return nil unless other.is_a?Dieta
		self.vct <=> other.vct
	end

	#formateo a string
	def to_s
		x = ""
		x << "#{titulo} (#{porcentaje_ingesta})\n"

		platos.each do |i|
			x << "- #{i[0]}, #{i[1]}, #{i[2]}g\n"
		end

		x << "V.C.T | %    #{vct} kcal | #{proteinas} #{grasas} #{hidratos}\n\n"
	end

end



#clase hija que representa grupos de alimentos
class DietaGrupo < Dieta

	#attr
	attr_accessor :grupo

	#initialize
	def initialize (nombre)
		super(nombre)
		self.grupo
	end

	#función que permite especificar el grupo de alimentos al que pertenece la receta a modo de DSL
	def grupo_alimentos (text)
		self.grupo = text
	end

	#formateo que añade el grupo de alimentos con respecto al de la clase madre
	def to_s
		output = ""
		output << super.to_s
		output << "Perteneciente a: #{grupo}\n\n"
		output
	end

end



#clase hija que representa menús para grupos de personas según su edad
class DietaEdad < Dieta

	#attr
	attr_accessor :edades

	#initialize
	def initialize (nombre, &block)
		super(nombre)
		self.edades
	end

	#función que permite definir el grupo de edades a modo de DSL
	def grupo_edades (text)
		self.edades = text
	end

	#formateo que añade el grupo de alimentos con respecto al de la clase madre
	def to_s
		output = ""
		output << super.to_s
		output << "Para personas de: #{edades}\n\n"
		output
	end

end









































#END
